import { csv, select } from 'd3';
import { scatterPlot } from './scatterPlot';

const csvUrl =
  'https://gist.githubusercontent.com/YaminiSreeram/64b9cef153989a4632aea1b5787d2642/raw/3352cb06d21eece602e44315a1d7742b26d39a0b/cereals.csv';

const parseRow = (d) => {
  d.Calories = +d.Calories;
  d.Sugars = +d.Sugars;
  return d;
};

const width = window.innerWidth;
const height = window.innerHeight;
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

const main = async () => {
  const plot = scatterPlot()
    .width(width)
    .height(height)
    .data(await csv(csvUrl, parseRow))
    .xValue((d) => d.Sugars)
    .yValue((d) => d.Calories)
    .margin({
      top: 20,
      right: 20,
      bottom: 40,
      left: 50,
    })
    .radius(5);

  svg.call(plot);

  const columns = [
    'Sugars',
    'Fat',
    'Protein (g)',
    'Dietary Fiber',
  ];
  let i = 0;
  setInterval(() => {
    plot.xValue((d) => d[columns[i % columns.length]]);
    svg.call(plot);
    i++;
  }, 2000);
};
main();
